//GoHserver.java: Copyright (C) 2001 Thomas Repantis <darkzero@otenet.gr>
//
//
//    This program is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program; if not, write to the Free Software
//    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
//

//The gates of heaven, or the gates of hell?

import java.net.*;
import java.io.*;


//GoHserver listens for client connection requests and hands them in to
//GoHthread to get served. This way concurrency is achieved.


public class GoHserver {


    public static void main(String[] args) throws IOException {

	//******************************************************************
	//_______________
	//Variables used.
	//---------------

	Integer port2listen = new Integer(14000); //Default port2listen.
	boolean logflag = false;               //Logging off by default. 

	String arg;
	int i = 0;

	ServerSocket serverSocket = null;
        boolean listening = true;

	//******************************************************************

	//******************************************************************
	//___________________
	//Introduce yourself.
	//-------------------

	System.out.println();
	System.out.println("GoHserver");
	System.out.println("Copyright (C) 2001 Thomas Repantis <darkzero@otenet.gr>");   
	System.out.println("Terminate with Ctrl+C.");
	System.out.println("java GoHserver -h for help");
	System.out.println();

	//******************************************************************


	//******************************************************************
	//____________________________
	//Do the command line parsing.
	//----------------------------
	
	while (i < args.length && args[i].startsWith("-")) {

            arg = args[i++];
	    

	    if (arg.equals("-port2listen")){
		if (i < args.length){
		    try{
			port2listen = new Integer(port2listen.parseInt(args[i++]));   
		    } catch (NumberFormatException e) {
			System.err.println("Invalid port number.");
			System.exit(1);		
		    }
		}
		else{
		    System.out.println();
		    System.err.println("-port2listen requires a portnumber");
		    System.err.println("java TCPAgent -h for help");
		    System.out.println();
		    System.exit(1);
		}
	    }


	    else if (arg.equals("-log")){
		logflag = true;
		System.out.println();	
		System.out.println("Logging enabled. See file GoHserver.log.");
		System.out.println();
	    }

	    else if (arg.equals("-h")){
		//Give the poor user a little help...

		//***Hint1***
		System.out.println();
		System.out.println("Gates of Heaven/Hell's purpose in life is to allow users from other machines to control connection to and disconnection from the Internet on an Internet gateway.");

		//***Hint2***
		System.out.println();
		System.out.println("Usage: java GoHserver [-h] [-port2listen portnumber] [-log]");

		//***Hint3***
		System.out.println();
		System.out.println("GoHserver will listen for GoHclients' connections on the specified port (or on port 14000 by default) and once triggered will run the commands necessary to connect to the Internet or to disconnect from it and log this action in file GoHserver.log, if invoked with the -log argument.");

		//***Hint4***
		System.out.println();
		System.out.println("This program comes with ABSOLUTELY NO WARRANTY. This is free software, and you are welcome to redistribute it under certain conditions. TCPAgent is licensed under the GNU General Public License. See the file COPYING for details.");
	    	System.out.println();
		System.exit(1);
	    }
	    
	    else {
		System.err.println("Error in the command line arguments passed.");
		System.err.println("java GoHserver -h for help");
		System.exit(1);
	    }
	}

	if (i != args.length){
	    System.err.println("Error in the command line arguments passed.");
	    System.err.println("java GoHserver -h for help");
	    System.exit(1);
	}

	else{
	    System.out.println("Listening for connections on port: " + port2listen);
	    if( logflag == true ){
		System.out.println("Logging is enabled.");
	    }
	    if( logflag == false ){
		System.out.println("Logging is disabled.");
	    }
	}
	    
	//******************************************************************
 

	//******************************************************************
	//___________________________________________________
	//Start listening for connections of GoHclients. 
	//---------------------------------------------------


        try {
            serverSocket = new ServerSocket(port2listen.intValue());
	    //The user should normally not need to change the listening port,
	    //since this should be standard for the GoHserver (an unused
	    //registered port chosen by the implementor (me ;-)). However the
	    //ability to change it is provided, in case something else is
	    //running there.

        } catch (IOException e) {
            System.err.println("Could not listen on port: " + port2listen);
            System.exit(-1);
        }

        while (listening)
            new GoHthread(serverSocket.accept(), logflag).start();
	//The server's client calls the server and gives him either the
	//connect or the disconnect command.
	serverSocket.close();

	//******************************************************************
    }
}




